package codegenerator;


import java.util.Vector;

import codegenerator.Entrada.Ent;



public class EntradaGeracaoCodigo {
	
	public enum Escopo{GLOBAL,LOCAL, ARGUMENTO} 
	
	private String identificador;
	private String tipo;
	private Ent tipoEntrada;
	//private int nivel;
	private Escopo escopo;
	private Vector<Parametro> parametros;
	private String codigo; 
	//private boolean constante;
	
	public EntradaGeracaoCodigo(String id, String t, Ent tipoEnt, Escopo escopo, Vector<Parametro> params, String codigo){
		this.setIdentificador(id);
		this.setTipo(t);
		this.setTipoEntrada(tipoEnt, params);
		this.setEscopo(escopo);
		//this.setConstante(constante);
		this.setCodigo(codigo);
	}
	
	public EntradaGeracaoCodigo() {
	}

	public Vector<Parametro> getParametros() {
		return parametros;
	}
	public void setParametros(Vector<Parametro> parametros) {
		this.parametros = parametros;
	}

	public Ent getTipoEntrada() {
		return tipoEntrada;
	}
	public void setTipoEntrada(Ent tipoEntrada, Vector<Parametro> parametros) {
		if(tipoEntrada.ordinal() == Entrada.Ent.FUNC.ordinal()){
			this.setParametros(parametros);
		}
		this.tipoEntrada = tipoEntrada;
	}
	

	public Escopo getEscopo() {
		return escopo;
	}

	public void setEscopo(Escopo escopo) {
		this.escopo = escopo;
	}

	public String getIdentificador() {
		return identificador;
	}

	public void setIdentificador(String identificador) {
		this.identificador = identificador;
	}

	public String getTipo() {
		return tipo;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}

	public void setTipoEntrada(Ent tipoEntrada) {
		this.tipoEntrada = tipoEntrada;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

}
