package codegenerator;

import java.util.Vector;

public class Entrada {
	//protected enum Nivel {GLOBAL, LOCAL, ARGUMENTO}
	public enum Ent {VAR, FUNC}
	
	
	
	private String identificador;
	private String tipo;
	private Ent tipoEntrada;
	private int nivel;
	private Vector<String> parametros;
	private boolean constante;
	
	public Entrada(String id, String t, Ent tipoEnt, int nivel, Vector<String> params, boolean constante){
		this.setIdentificador(id);
		this.setTipo(t);
		this.setTipoEntrada(tipoEnt, params);
		this.setNivel(nivel);
		this.setConstante(constante);
	}
	
	public Entrada() {
	}

	public Vector<String> getParametros() {
		return parametros;
	}
	public void setParametros(Vector<String> parametros) {
		this.parametros = parametros;
	}

	public Ent getTipoEntrada() {
		return tipoEntrada;
	}
	public void setTipoEntrada(Ent tipoEntrada, Vector<String> parametros) {
		if(tipoEntrada.ordinal() == Entrada.Ent.FUNC.ordinal()){
			this.setParametros(parametros);
		}
		this.tipoEntrada = tipoEntrada;
	}

	public int getNivel() {
		return nivel;
	}
	public void setNivel(int nivel) {
		this.nivel = nivel;
	}

	public String getIdentificador() {
		return identificador;
	}

	public void setIdentificador(String identificador) {
		this.identificador = identificador;
	}

	public String getTipo() {
		return tipo;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}

	public void setTipoEntrada(Ent tipoEntrada) {
		this.tipoEntrada = tipoEntrada;
	}

	public boolean isConstante() {
		return constante;
	}

	public void setConstante(boolean constante) {
		this.constante = constante;
	}
}
