package codegenerator;

public class Variavel {

	private String identificador;
	private String tipo;
	private String codigoValor;
	
	public Variavel(String id, String tipo, String valor){
		this.identificador = id;
		this.tipo = tipo;
		this.codigoValor = valor;
	}
	
	public String getIdentificador() {
		return identificador;
	}
	public void setIdentificador(String identificador) {
		this.identificador = identificador;
	}
	public String getTipo() {
		return tipo;
	}
	public void setTipo(String tipo) {
		tipo = tipo.trim().toUpperCase();
		if(tipo.equals("CHAR")){
			this.tipo = "char";
		}else if(tipo.equals("INTEGER")){
			this.tipo = "int32";
		}else if(tipo.equals("BOOLEAN")){
			this.tipo = "bool";
		}else{
			System.out.println("algo errado");
		}
	}

	public String getValor() {
		return codigoValor;
	}

	public void setValor(String valor) {
		this.codigoValor = valor;
	}
}
